module Cd_adder(a_in,
      b_in,
      add_nsub,
      s_out
);

	input [31:0] a_in;
	input [31:0] b_in;
	input add_nsub;
	output [31:0] s_out;

	wire [31:0] b;
	wire [30:0] c;
	wire c_in;

	assign b = (add_nsub) ? b_in : (~b_in);
	assign c_in = (add_nsub) ? 1'b0 : 1'b1;

	
	// P, G generate and sum calculation
	fa fa0  (.a(a_in[ 0]), .b(b[ 0]), .c(c_in) , .p(p00), .g(g00), .sum(s_out[ 0]));
	fa fa1  (.a(a_in[ 1]), .b(b[ 1]), .c(c[ 0]), .p(p01), .g(g01), .sum(s_out[ 1]));
	fa fa2  (.a(a_in[ 2]), .b(b[ 2]), .c(c[ 1]), .p(p02), .g(g02), .sum(s_out[ 2]));
	fa fa3  (.a(a_in[ 3]), .b(b[ 3]), .c(c[ 2]), .p(p03), .g(g03), .sum(s_out[ 3]));
	fa fa4  (.a(a_in[ 4]), .b(b[ 4]), .c(c[ 3]), .p(p04), .g(g04), .sum(s_out[ 4]));
	fa fa5  (.a(a_in[ 5]), .b(b[ 5]), .c(c[ 4]), .p(p05), .g(g05), .sum(s_out[ 5]));
	fa fa6  (.a(a_in[ 6]), .b(b[ 6]), .c(c[ 5]), .p(p06), .g(g06), .sum(s_out[ 6]));
	fa fa7  (.a(a_in[ 7]), .b(b[ 7]), .c(c[ 6]), .p(p07), .g(g07), .sum(s_out[ 7]));
	fa fa8  (.a(a_in[ 8]), .b(b[ 8]), .c(c[ 7]), .p(p08), .g(g08), .sum(s_out[ 8]));
	fa fa9  (.a(a_in[ 9]), .b(b[ 9]), .c(c[ 8]), .p(p09), .g(g09), .sum(s_out[ 9]));
	fa fa10 (.a(a_in[10]), .b(b[10]), .c(c[ 9]), .p(p10), .g(g10), .sum(s_out[10]));
	fa fa11 (.a(a_in[11]), .b(b[11]), .c(c[10]), .p(p11), .g(g11), .sum(s_out[11]));
	fa fa12 (.a(a_in[12]), .b(b[12]), .c(c[11]), .p(p12), .g(g12), .sum(s_out[12]));
	fa fa13 (.a(a_in[13]), .b(b[13]), .c(c[12]), .p(p13), .g(g13), .sum(s_out[13]));
	fa fa14 (.a(a_in[14]), .b(b[14]), .c(c[13]), .p(p14), .g(g14), .sum(s_out[14]));
	fa fa15 (.a(a_in[15]), .b(b[15]), .c(c[14]), .p(p15), .g(g15), .sum(s_out[15]));
	fa fa16 (.a(a_in[16]), .b(b[16]), .c(c[15]), .p(p16), .g(g16), .sum(s_out[16]));
	fa fa17 (.a(a_in[17]), .b(b[17]), .c(c[16]), .p(p17), .g(g17), .sum(s_out[17]));
	fa fa18 (.a(a_in[18]), .b(b[18]), .c(c[17]), .p(p18), .g(g18), .sum(s_out[18]));
	fa fa19 (.a(a_in[19]), .b(b[19]), .c(c[18]), .p(p19), .g(g19), .sum(s_out[19]));
	fa fa20 (.a(a_in[20]), .b(b[20]), .c(c[19]), .p(p20), .g(g20), .sum(s_out[20]));
	fa fa21 (.a(a_in[21]), .b(b[21]), .c(c[20]), .p(p21), .g(g21), .sum(s_out[21]));
	fa fa22 (.a(a_in[22]), .b(b[22]), .c(c[21]), .p(p22), .g(g22), .sum(s_out[22]));
	fa fa23 (.a(a_in[23]), .b(b[23]), .c(c[22]), .p(p23), .g(g23), .sum(s_out[23]));
	fa fa24 (.a(a_in[24]), .b(b[24]), .c(c[23]), .p(p24), .g(g24), .sum(s_out[24]));
	fa fa25 (.a(a_in[25]), .b(b[25]), .c(c[24]), .p(p25), .g(g25), .sum(s_out[25]));
	fa fa26 (.a(a_in[26]), .b(b[26]), .c(c[25]), .p(p26), .g(g26), .sum(s_out[26]));
	fa fa27 (.a(a_in[27]), .b(b[27]), .c(c[26]), .p(p27), .g(g27), .sum(s_out[27]));
	fa fa28 (.a(a_in[28]), .b(b[28]), .c(c[27]), .p(p28), .g(g28), .sum(s_out[28]));
	fa fa29 (.a(a_in[29]), .b(b[29]), .c(c[28]), .p(p29), .g(g29), .sum(s_out[29]));
	fa fa30 (.a(a_in[30]), .b(b[30]), .c(c[29]), .p(p30), .g(g30), .sum(s_out[30]));
	fa fa31 (.a(a_in[31]), .b(b[31]), .c(c[30]), .p(p31), .g(g31), .sum(s_out[31]));
	

	// 1st stage
	gray  g1_0  (c_in, g00, p00,      c[0]);
	black b1_1  (g00 , g01, p00, p01, g01_00, p01_00);
	black b1_2  (g01 , g02, p01, p02, g02_01, p02_01);
	black b1_3  (g02 , g03, p02, p03, g03_02, p03_02);
	black b1_4  (g03 , g04, p03, p04, g04_03, p04_03);
	black b1_5  (g04 , g05, p04, p05, g05_04, p05_04);
	black b1_6  (g05 , g06, p05, p06, g06_05, p06_05);
	black b1_7  (g06 , g07, p06, p07, g07_06, p07_06);
	black b1_8  (g07 , g08, p07, p08, g08_07, p08_07);
	black b1_9  (g08 , g09, p08, p09, g09_08, p09_08);
	black b1_10 (g09 , g10, p09, p10, g10_09, p10_09);
	black b1_11 (g10 , g11, p10, p11, g11_10, p11_10);
	black b1_12 (g11 , g12, p11, p12, g12_11, p12_11);
	black b1_13 (g12 , g13, p12, p13, g13_12, p13_12);
	black b1_14 (g13 , g14, p13, p14, g14_13, p14_13);
	black b1_15 (g14 , g15, p14, p15, g15_14, p15_14);
	black b1_16 (g15 , g16, p15, p16, g16_15, p16_15);
	black b1_17 (g16 , g17, p16, p17, g17_16, p17_16);
	black b1_18 (g17 , g18, p17, p18, g18_17, p18_17);
	black b1_19 (g18 , g19, p18, p19, g19_18, p19_18);
	black b1_20 (g19 , g20, p19, p20, g20_19, p20_19);
	black b1_21 (g20 , g21, p20, p21, g21_20, p21_20);
	black b1_22 (g21 , g22, p21, p22, g22_21, p22_21);
	black b1_23 (g22 , g23, p22, p23, g23_22, p23_22);
	black b1_24 (g23 , g24, p23, p24, g24_23, p24_23);
	black b1_25 (g24 , g25, p24, p25, g25_24, p25_24);
	black b1_26 (g25 , g26, p25, p26, g26_25, p26_25);
	black b1_27 (g26 , g27, p26, p27, g27_26, p27_26);
	black b1_28 (g27 , g28, p27, p28, g28_27, p28_27);
	black b1_29 (g28 , g29, p28, p29, g29_28, p29_28);
	black b1_30 (g29 , g30, p29, p30, g30_29, p30_29);
	black b1_31 (g30 , g31, p30, p31, g31_30, p31_30);
	


	// 2nd stage
	gray  g2_1  (c_in  , g01_00,         p01_00, c[ 1]);
	gray  g2_2  (c[ 0] , g02_01,         p02_01, c[ 2]);
	black b2_3  (g01_00, g03_02, p01_00, p03_02, g03_00, p03_00);
	black b2_4  (g02_01, g04_03, p02_01, p04_03, g04_01, p04_01);
	black b2_5  (g03_02, g05_04, p03_02, p05_04, g05_02, p05_02);
	black b2_6  (g04_03, g06_05, p04_03, p06_05, g06_03, p06_03);
	black b2_7  (g05_04, g07_06, p05_04, p07_06, g07_04, p07_04);
	black b2_8  (g06_05, g08_07, p06_05, p08_07, g08_05, p08_05);
	black b2_9  (g07_06, g09_08, p07_06, p09_08, g09_06, p09_06);
	black b2_10 (g08_07, g10_09, p08_07, p10_09, g10_07, p10_07);
	black b2_11 (g09_08, g11_10, p09_08, p11_10, g11_08, p11_08);
	black b2_12 (g10_09, g12_11, p10_09, p12_11, g12_09, p12_09);
	black b2_13 (g11_10, g13_12, p11_10, p13_12, g13_10, p13_10);
	black b2_14 (g12_11, g14_13, p12_11, p14_13, g14_11, p14_11);
	black b2_15 (g13_12, g15_14, p13_12, p15_14, g15_12, p15_12);
	black b2_16 (g14_13, g16_15, p14_13, p16_15, g16_13, p16_13);
	black b2_17 (g15_14, g17_16, p15_14, p17_16, g17_14, p17_14);
	black b2_18 (g16_15, g18_17, p16_15, p18_17, g18_15, p18_15);
	black b2_19 (g17_16, g19_18, p17_16, p19_18, g19_16, p19_16);
	black b2_20 (g18_17, g20_19, p18_17, p20_19, g20_17, p20_17);
	black b2_21 (g19_18, g21_20, p19_18, p21_20, g21_18, p21_18);
	black b2_22 (g20_19, g22_21, p20_19, p22_21, g22_19, p22_19);
	black b2_23 (g21_20, g23_22, p21_20, p23_22, g23_20, p23_20);
	black b2_24 (g22_21, g24_23, p22_21, p24_23, g24_21, p24_21);
	black b2_25 (g23_22, g25_24, p23_22, p25_24, g25_22, p25_22);
	black b2_26 (g24_23, g26_25, p24_23, p26_25, g26_23, p26_23);
	black b2_27 (g25_24, g27_26, p25_24, p27_26, g27_24, p27_24);
	black b2_28 (g26_25, g28_27, p26_25, p28_27, g28_25, p28_25);
	black b2_29 (g27_26, g29_28, p27_26, p29_28, g29_26, p29_26);
	black b2_30 (g28_27, g30_29, p28_27, p30_29, g30_27, p30_27);
	black b2_31 (g29_28, g31_30, p29_28, p31_30, g31_28, p31_28);


	// 3rd stage
	gray  g3_3  (c_in  , g03_00,         p03_00, c[ 3]);
	gray  g3_4  (c[ 0] , g04_01,         p04_01, c[ 4]);
	gray  g3_5  (c[ 1] , g05_02,         p05_02, c[ 5]);
	gray  g3_6  (c[ 2] , g06_03,         p06_03, c[ 6]);
	black b3_7  (g03_00, g07_04, p03_00, p07_04, g07_00, p07_00);
	black b3_8  (g04_01, g08_05, p04_01, p08_05, g08_01, p08_01);
	black b3_9  (g05_02, g09_06, p05_02, p09_06, g09_02, p09_02);
	black b3_10 (g06_03, g10_07, p06_03, p10_07, g10_03, p10_03);
	black b3_11 (g07_04, g11_08, p07_04, p11_08, g11_04, p11_04);
	black b3_12 (g08_05, g12_09, p08_05, p12_09, g12_05, p12_05);
	black b3_13 (g09_06, g13_10, p09_06, p13_10, g13_06, p13_06);
	black b3_14 (g10_07, g14_11, p10_07, p14_11, g14_07, p14_07);
	black b3_15 (g11_08, g15_12, p11_08, p15_12, g15_08, p15_08);
	black b3_16 (g12_09, g16_13, p12_09, p16_13, g16_09, p16_09);
	black b3_17 (g13_10, g17_14, p13_10, p17_14, g17_10, p17_10);
	black b3_18 (g14_11, g18_15, p14_11, p18_15, g18_11, p18_11);
	black b3_19 (g15_12, g19_16, p15_12, p19_16, g19_12, p19_12);
	black b3_20 (g16_13, g20_17, p16_13, p20_17, g20_13, p20_13);
	black b3_21 (g17_14, g21_18, p17_14, p21_18, g21_14, p21_14);
	black b3_22 (g18_15, g22_19, p18_15, p22_19, g22_15, p22_15);
	black b3_23 (g19_16, g23_20, p19_16, p23_20, g23_16, p23_16);
	black b3_24 (g20_17, g24_21, p20_17, p24_21, g24_17, p24_17);
	black b3_25 (g21_18, g25_22, p21_18, p25_22, g25_18, p25_18);
	black b3_26 (g22_19, g26_23, p22_19, p26_23, g26_19, p26_19);
	black b3_27 (g23_20, g27_24, p23_20, p27_24, g27_20, p27_20);
	black b3_28 (g24_21, g28_25, p24_21, p28_25, g28_21, p28_21);
	black b3_29 (g25_22, g29_26, p25_22, p29_26, g29_22, p29_22);
	black b3_30 (g26_23, g30_27, p26_23, p30_27, g30_23, p30_23);
	black b3_31 (g27_24, g31_28, p27_24, p31_28, g31_24, p31_24);


	// 4th stage
	gray  g4_7  (c_in  , g07_00,         p07_00, c[ 7]);
	gray  g4_8  (c[ 0] , g08_01,         p08_01, c[ 8]);
	gray  g4_9  (c[ 1] , g09_02,         p09_02, c[ 9]);
	gray  g4_10 (c[ 2] , g10_03,         p10_03, c[10]);
	gray  g4_11 (c[ 3] , g11_04,         p11_04, c[11]);
	gray  g4_12 (c[ 4] , g12_05,         p12_05, c[12]);
	gray  g4_13 (c[ 5] , g13_06,         p13_06, c[13]);
	gray  g4_14 (c[ 6] , g14_07,         p14_07, c[14]);
	black b4_15 (g07_00, g15_08, p07_00, p15_08, g15_00, p15_00);
	black b4_16 (g08_01, g16_09, p08_01, p16_09, g16_01, p16_01);
	black b4_17 (g09_02, g17_10, p09_02, p17_10, g17_02, p17_02);
	black b4_18 (g10_03, g18_11, p10_03, p18_11, g18_03, p18_03);
	black b4_19 (g11_04, g19_12, p11_04, p19_12, g19_04, p19_04);
	black b4_20 (g12_05, g20_13, p12_05, p20_13, g20_05, p20_05);
	black b4_21 (g13_06, g21_14, p13_06, p21_14, g21_06, p21_06);
	black b4_22 (g14_07, g22_15, p14_07, p22_15, g22_07, p22_07);
	black b4_23 (g15_08, g23_16, p15_08, p23_16, g23_08, p23_08);
	black b4_24 (g16_09, g24_17, p16_09, p24_17, g24_09, p24_09);
	black b4_25 (g17_10, g25_18, p17_10, p25_18, g25_10, p25_10);
	black b4_26 (g18_11, g26_19, p18_11, p26_19, g26_11, p26_11);
	black b4_27 (g19_12, g27_20, p19_12, p27_20, g27_12, p27_12);
	black b4_28 (g20_13, g28_21, p20_13, p28_21, g28_13, p28_13);
	black b4_29 (g21_14, g29_22, p21_14, p29_22, g29_14, p29_14);
	black b4_30 (g22_15, g30_23, p22_15, p30_23, g30_15, p30_15);
	black b4_31 (g23_16, g31_24, p23_16, p31_24, g31_16, p31_16);


	// 5th stage
	gray  g5_15 (c_in  , g15_00,         p15_00, c[15]);
	gray  g5_16 (c[ 0] , g16_01,         p16_01, c[16]);
	gray  g5_17 (c[ 1] , g17_02,         p17_02, c[17]);
	gray  g5_18 (c[ 2] , g18_03,         p18_03, c[18]);
	gray  g5_19 (c[ 3] , g19_04,         p19_04, c[19]);
	gray  g5_20 (c[ 4] , g20_05,         p20_05, c[20]);
	gray  g5_21 (c[ 5] , g21_06,         p21_06, c[21]);
	gray  g5_22 (c[ 6] , g22_07,         p22_07, c[22]);
	gray  g5_23 (c[ 7] , g23_08,         p23_08, c[23]);
	gray  g5_24 (c[ 8] , g24_09,         p24_09, c[24]);
	gray  g5_25 (c[ 9] , g25_10,         p25_10, c[25]);
	gray  g5_26 (c[10] , g26_11,         p26_11, c[26]);
	gray  g5_27 (c[11] , g27_12,         p27_12, c[27]);
	gray  g5_28 (c[12] , g28_13,         p28_13, c[28]);
	gray  g5_29 (c[13] , g29_14,         p29_14, c[29]);
	gray  g5_30 (c[14] , g30_15,         p30_15, c[30]);

endmodule




module gray(
	g_l, g_h, p_h,
	g_out
);

	

	input g_l, g_h, p_h;
	output g_out;

	not  i0 (n0, g_h);
	nand i1 (n1, g_l, p_h);
	nand i2 (g_out, n0, n1);

endmodule




module black(
	g_l, g_h, p_l, p_h,
	g_out, p_out
);

	input g_l, g_h, p_l, p_h;
	output g_out, p_out;

	not  i0 (n0, g_h);
	nand i1 (n1, g_l, p_h);
	nand i2 (n2, p_l, p_h);
	nand i3 (g_out, n1, n0);
	not  i4 (p_out, n2);


endmodule




module fa(
	a, b, c,
	p, g, sum
);

	input a, b, c;
	output p, g, sum;

	nand i0  (n2, b, a);
	nor  i1  (n1, a, b);
	not  i2  (g, n2);
	not  i3  (p, n1);
	nor  i4  (n5, g, n1);
	nor  i5  (n6, n5, c);
	nand i6  (n7, c, n5);
	not  i7  (n8, n7);
	nor  i8  (sum, n6, n8);
	

endmodule
