//====================================================================
// NAME: cd_shifter.v
// DESC: 32-bit ASR shifter
// HISTORY
// 11/22/2005: 
//	- first draft
//====================================================================


module Cd_shifter(
	a_in,
	b_out,
	shift_count //right shift count
	);

input [31:0] a_in;
output [31:0] b_out;
input [4:0] shift_count;

wire [31:0] b_mask;

assign b_out = (a_in >> shift_count)|b_mask;
assign b_mask = a_in[31]==1'b0 ? 32'h0:~(32'hffffffff>>shift_count);

endmodule


