//====================================================================
// NAME: cd_top.v
// DESC: cordic design top
// HISTORY
// 11/22/2005: 
// 	- first draft
//====================================================================

module Cd_top(
	PCLK,
	PRESETn,
	PSEL,
	PADDR,
        PENABLE,
	PWRITE,
	PWDATA,
	PRDATA,
	INT
);


input PCLK;
input PRESETn;
input PSEL;
input [4:0] PADDR;
input PENABLE;
input PWRITE;
input [31:0] PWDATA;
output [31:0] PRDATA;
output INT;

wire [31:0] reg_ctrl;
wire [31:0] reg_x_in;
wire [31:0] reg_y_in;
wire [31:0] reg_z_in;

wire [31:0] reg_x_out;
wire [31:0] reg_y_out;
wire [31:0] reg_z_out;
wire [31:0] reg_status;



Cd_APB_if cd_apb_if(	.PCLK(PCLK),
			.PRESETn(PRESETn),
			.PSEL(PSEL),
			.PADDR(PADDR),
			.PENABLE(PENABLE),
			.PWRITE(PWRITE),
			.PWDATA(PWDATA),
			.PRDATA(PRDATA),
			.INT(INT),
			.reg_ctrl(reg_ctrl),
			.reg_x_in(reg_x_in),
			.reg_y_in(reg_y_in),
			.reg_z_in(reg_z_in),
			.reg_x_out(reg_x_out),
			.reg_y_out(reg_y_out),
			.reg_z_out(reg_z_out),
			.reg_status(reg_status)
			);


Cd_main cd_main(.PCLK(PCLK),	
		.PRESETn(PRESETn),
		.reg_ctrl(reg_ctrl),
		.reg_x_in(reg_x_in),
		.reg_y_in(reg_y_in),
		.reg_z_in(reg_z_in),
		.reg_x_out(reg_x_out),
		.reg_y_out(reg_y_out),
		.reg_z_out(reg_z_out),
		.reg_status(reg_status)
		);	


endmodule


